-- Scriptfile to upgrade tablespaces on D@BPINDEX@ z/OS v9
------------------------------------------------------------------------
-- Process this script in the D@BPINDEX@ command line processor
-- example: d@BPINDEX@ -tf upgradeSchema602_customization.sql

-- *******************************************
-- Create the CUSTPROPERTIES table
-- *******************************************

CREATE TABLE @SCHEMA@.CUSTPROPERTIES
  (PROPERTYID VARCHAR (128) NOT NULL,
   ARTIFACTTNS VARCHAR(250) NOT NULL,
   ARTIFACTNAME VARCHAR(200) NOT NULL,
   ARTIFACTTYPE VARCHAR(50) NOT NULL,
   PNAME VARCHAR(250) NOT NULL,
   PVALUE VARCHAR(250) NOT NULL,
   PTYPE VARCHAR (16) NOT NULL,
   CONSTRAINT PK_CUSTPROPERTIES PRIMARY KEY (PROPERTYID) )
   IN @DB_NAME@.APTIMETS;

CREATE UNIQUE INDEX @SCHEMA@.CUSTPROP0_PK
 ON @SCHEMA@.CUSTPROPERTIES (PROPERTYID)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;

CREATE INDEX @SCHEMA@.CUSTPROP1_PK
 ON @SCHEMA@.CUSTPROPERTIES (ARTIFACTTYPE, ARTIFACTTNS)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;

CREATE INDEX @SCHEMA@.CUSTPROP2_PK
 ON @SCHEMA@.CUSTPROPERTIES (ARTIFACTTYPE, ARTIFACTNAME)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;
      
CREATE INDEX @SCHEMA@.CUSTPROP3_PK
 ON @SCHEMA@.CUSTPROPERTIES (ARTIFACTTYPE, ARTIFACTNAME, ARTIFACTTNS)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;      
  
CREATE INDEX @SCHEMA@.CUSTPROP4_PK
 ON @SCHEMA@.CUSTPROPERTIES (ARTIFACTTYPE, PNAME)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;        
           
CREATE INDEX @SCHEMA@.CUSTPROP5_PK
 ON @SCHEMA@.CUSTPROPERTIES (ARTIFACTTYPE, ARTIFACTTNS, PNAME)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;                  
