--BEGIN CMVC
--********************************************************************
--
--  Workfile: Not used for zOS script
--  Last update: %E% %U%
--  SCCS path, id: %F% %I%
--
--********************************************************************
--END CMVC
--BEGIN COPYRIGHT
--********************************************************************
--
--  Licensed Materials - Property of IBM
--  5724-L01, 5655-N53, 5724-I82, 5655-R15
--  Copyright IBM Corporation 2004, 2009
--  All rights reserved. US Government Users Restricted Rights - Use,
--  duplication, or disclosure restricted by GSA ADP Schedule Contract
--  with IBM Corp.
--
--********************************************************************
--END COPYRIGHT
--
-- Scriptfile to create schema (tables) in DB2 on iSeries
----------------------------------------------------------------------
-- The code assumes an implicit schema, i.e. the tables
-- and views have to be created in a collection that has
-- the name of the user connected to use the product.
-- You may want to create the collection using:
--     db2 create collection <username>
-- before applying this script
----------------------------------------------------------------------
-- 1. Process this script in the DB2 command line processor
-- Example:
--  db2 connect to <dbname> user <user name> using <user password>
--  db2 -tf createTable_AppScheduler.sql

-- create the schema

-- *******************************************
-- Create tablespaces
-- *******************************************
CREATE TABLESPACE TEMPLATE
 IN @DB_NAME@
 USING STOGROUP @STOGRP@
 CCSID UNICODE
 DEFINE NO
 SEGSIZE 32
 LOCKSIZE ANY
 BUFFERPOOL @BPTABLE4K@;

CREATE TABLESPACE SCHWPTS
 IN @DB_NAME@
 USING STOGROUP @STOGRP@
 CCSID UNICODE
 DEFINE NO
 SEGSIZE 32
 LOCKSIZE ANY
 BUFFERPOOL @BPTABLE4K@;

CREATE LOB TABLESPACE SCHWPTS1
 IN @DB_NAME@
 USING STOGROUP @STOGRP@
 LOCKSIZE LOB
 BUFFERPOOL @BPLOB4K@;

CREATE TABLE @SCHEMA@.WSCH_TASK
(
  TASKID             NUMERIC(19)           NOT NULL ,
  VERSION            VARCHAR(5)            NOT NULL ,
  ROW_VERSION        INTEGER               NOT NULL ,
  TASKTYPE           INTEGER               NOT NULL ,
  TASKSUSPENDED      SMALLINT              NOT NULL ,
  CANCELLED          SMALLINT              NOT NULL ,
  NEXTFIRETIME       NUMERIC(19)           NOT NULL ,
  STARTBYINTERVAL    VARCHAR(254)                   ,
  STARTBYTIME        NUMERIC(19)                    ,
  VALIDFROMTIME      NUMERIC(19)                    ,
  VALIDTOTIME        NUMERIC(19)                    ,
  REPEATINTERVAL     VARCHAR(254)                   ,
  MAXREPEATS         INTEGER               NOT NULL ,
  REPEATSLEFT        INTEGER               NOT NULL ,
  TASKINFO           BLOB(102400)                   ,
  NAME               VARCHAR(254)          NOT NULL ,
  AUTOPURGE          INTEGER               NOT NULL ,
  FAILUREACTION      INTEGER                        ,
  MAXATTEMPTS        INTEGER                        ,
  QOS                INTEGER                        ,
  PARTITIONID        INTEGER                        ,
  OWNERTOKEN         VARCHAR(200)          NOT NULL ,
  CREATETIME         NUMERIC(19)           NOT NULL ,
  ROW_ID             ROWID                 NOT NULL GENERATED ALWAYS,
  PRIMARY KEY (TASKID)
)
IN @DB_NAME@.SCHWPTS;

CREATE UNIQUE INDEX @SCHEMA@.WSCH_TASKPK ON @SCHEMA@.WSCH_TASK (TASKID)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@;

CREATE INDEX @SCHEMA@.WSCH_TASK_IDX1 ON @SCHEMA@.WSCH_TASK 
(
 TASKID,
 OWNERTOKEN
)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;

CREATE INDEX @SCHEMA@.WSCH_TASK_IDX2 ON @SCHEMA@.WSCH_TASK
(
  NEXTFIRETIME ASC ,
  REPEATSLEFT ,
  PARTITIONID
)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@;

CREATE AUX TABLE @SCHEMA@.WSCH_TASK1
 IN @DB_NAME@.SCHWPTS1
 STORES @SCHEMA@.WSCH_TASK COLUMN TASKINFO;

CREATE UNIQUE INDEX @SCHEMA@.WSCH_TASK1I
 ON @SCHEMA@.WSCH_TASK1
 USING STOGROUP @STOGRP@
 BUFFERPOOL @BPINDEX@;

CREATE TABLE @SCHEMA@.WSCH_TREG
(
  REGKEY             VARCHAR(254)          NOT NULL ,
  REGVALUE           VARCHAR(254)                  ,
  PRIMARY KEY ( REGKEY )
)
IN @DB_NAME@.SCHWPTS;

 -- unique index for primary key
CREATE UNIQUE INDEX @SCHEMA@.WSCH_TREGPK
 ON @SCHEMA@.WSCH_TREG (REGKEY)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;

CREATE TABLE @SCHEMA@.WSCH_LMGR
(
  LEASENAME          VARCHAR(254)          NOT NULL ,
  LEASEOWNER         VARCHAR(254)          NOT NULL ,
  LEASE_EXPIRE_TIME  NUMERIC(19)                    ,
  DISABLED           VARCHAR(5)                     ,
  PRIMARY KEY (LEASENAME)
)
IN @DB_NAME@.SCHWPTS;

CREATE UNIQUE INDEX @SCHEMA@.WSCH_LMGRPK
 ON @SCHEMA@.WSCH_LMGR (LEASENAME)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;

CREATE TABLE @SCHEMA@.WSCH_LMPR
(
  LEASENAME          VARCHAR(254)          NOT NULL ,
  NAME               VARCHAR(254)          NOT NULL ,
  VALUE              VARCHAR(254)          NOT NULL ,
  PRIMARY KEY (LEASENAME)
)
IN @DB_NAME@.SCHWPTS;

CREATE UNIQUE INDEX @SCHEMA@.WSCH_LMPRPK
 ON @SCHEMA@.WSCH_LMPR (LEASENAME)
 USING STOGROUP @STOGRP@
 DEFINE NO
 BUFFERPOOL @BPINDEX@
 NOT PADDED;
